
package de.ivu.elect.presentation.entschaedigung.menu;

import javax.inject.Inject;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungsartCreateParameters;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.entschaedigung.EntschaedigungsartCreateView;

public abstract class AbstractEntschaedigungsartCreateMenuItemEntry extends AbstractEntschaedigungsartMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  @ConversationGroup(EntschaedigungsartCreateParameters.class)
  protected transient EntschaedigungsartCreateParameters entschaedigungsartCreateParameters;

  public AbstractEntschaedigungsartCreateMenuItemEntry() {
    super();
  }

  @Override
  protected UseCasePermission getUseCasePermission() {
    return UseCasePermission.ENTSCHAEDIGUNGSART_CREATE;
  }

  @Override
  public String getTargetViewId() {
    return null;
  }

  @Override
  public String doAction() {
    entschaedigungsartCreateParameters.reset();

    initTargetViewParameters(entschaedigungsartCreateParameters);

    return EntschaedigungsartCreateView.VIEW_ID;
  }

  protected abstract void initTargetViewParameters(EntschaedigungsartCreateParameters entschaedigungsartCreateParameters);

  @Override
  protected String getLabel() {
    return getMessage(getLabelKey(), getMessage(getEntityKey()));
  }

  protected abstract String getEntityKey();

  @Override
  public String getLabelKey() {
    return "entity.create.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconCreate();
  }
}
